function y = add_awgn(x,rate,EbN0)
%  y = add_awgn(x,rate,EbN0)
%  Addition von weissem Gauss-Rauschen.
%  x :     Signalvektor mit den Bits  +1 bzw -1
%  rate :  Code-Rate
%  EbN0 :  Eb/N0 in dB.
 
sigma = 1/sqrt(2*rate*(10^(EbN0/10))); % standard deviation of AWGN noise
y = x + sigma * randn(size(x));        % addition of noise
