function anzf = fanalytd(fsin)
% anzf = fanalytd(fsin)
% Animierte Darstellung des analytischen Sinus-Signals 
% der Frequenz fsin (in Einheiten der Abtastfrequenz).
% Im Anschluss an die Darstellung wird nach der Frequenz 
% gefragt und diese auf bereinstimmung mit fsin geprft.
% Dabei werden auch die Aliasfrequenzen akzeptiert.
% Abbruch durch Eingabe von inf (dort sind viele Alias).

% Autor: Klaus von der Heide, e-mail:  v.d.heide@on-line.de

eps = 0.02;         % geforderte Frequenzgenauigkeit
v   = 0.1;          % Tempo der Animation
sw  = 5;            % Schwelle fr dumme Antwort
m   = 32;           % Anzahl der Abtastungen im Bild
f   = mod(fsin+0.5,1) - 0.5; % transformieren nach -0.5..0.5
%analytsigd(2*f,0.02,0.98,10000,m,v,[90,0],1);
t   = 0:m;          % Zeitbereich
komplexanimat(exp(i*2*pi*f*t))% ,vis,velocity,blick,mark)
pause
anzf = 0;
incl = inputdlg('1/(#Abtastungen/Periode)','Frequenz');
freq = mod(eval(incl{1})+0.5,1) - 0.5;
while abs(freq - f)>eps
   anzf = anzf + 1;
   if anzf>sw  'Nicht raten!', end
   if abs(freq - f)<2*eps  '  Es ist knapp daneben!'; end 
   delete(gcf)
   analytsigd(2*f,0.02,0.98,10000,m,v,[90,0],1);
   incl = inputdlg('1/(#Abtastungen/Periode)','Noch einmal: Frequenz');
   freq = mod(eval(incl{1})+0.5,1) - 0.5;
end
delete(gcf)
'o.k.!  Die korrekte Frequenz ist:'
fsin
