function modulation(f0)
% f0 :  Trgerfrequenz  (Default = 40)
% Demonstration der Modulationsarten

% Autor: Klaus von der Heide, e-mail: v.d.heide@on-line.de

if nargin<1  f0 = 40; end
nf   = 40;
nfh  = floor(nf/2);
fsiz = 14;
bits = 2*[0 0 1 0 0 1 1 1 0 1 1 0 0] - 1;
bit2 = 2*[0 1 0 1 1 0 1 0 0 0 1 1 0] - 1;
bb   = nfach(bits,nf);
bb2  = nfach(bit2,nf);
y = raisedcosine(bits,nf);
y2= raisedcosine(bit2,nf);
fig1 = fullscreen('Raised Cos');
subplot(2,1,1); plot((1:length(bb))-nfh,bb>0); 
axis([0,length(y),-0.1,1.1])
title('Bitsequenz','FontSize',fsiz)
subplot(2,1,2); plot(1:length(y),y); 
axis([0,length(y),-1.2,1.2])
title('Raised Cosine','FontSize',fsiz)
set(gcf,'keypressfcn','togglevisibility');
amplmod(f0,y,1);
set(gcf,'keypressfcn','togglevisibility');
freqmod(f0,y,0.03);
set(gcf,'keypressfcn','togglevisibility');
phasenmod(f0,y,pi/2);
set(gcf,'keypressfcn','togglevisibility');
qammod(f0,y,y2);
set(gcf,'keypressfcn','togglevisibility');
