function x0 = p_dec_ok(n,r,p)
% x0 = p_dec_ok(n,r,p)
% Wahrscheinlichkeit richtiger Decodierung eines (n,k)-Codes 
% mit r-Bit-Korrektur bei der Bitfehlerwahrscheinlichkeit p.
% Die Binomialverteilung wird direkt berechnet (keine Approx.)
x0 = 0;
for i = 0:r
    x0 = x0 + prod((n-i+1):n)/prod(1:i)*(1-p)^(n-i)*p^i;
end;
