%
%
% Versuch 1:  Zeitbereich und Frequenzbereich%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE-16,'Color',MSVTITLCOLOR>
%
%
%
%  Die Fouriertransformation transformiert ein reellwertiges oder komplexwertiges Signal 
%  vom Zeitbereich in den Frequenzbereich.  Die Zeitvariable sei  {\fontname{Courier}t} , 
%  die Frequenzvariable  {\fontname{Courier}\omega = 2\pif} .  Der Frequenzbereich heisst auch Spektralbereich.
%
%  Gegeben sei das Signal  {\fontname{Courier}s(t)}.
%
%  Dann heisst
%         \infty                                            %<'FontName',MSVFORMFONT>
%  S(\omega) = _{\fontsize{24}\int} s(t) e^{-i\omegat} dt   %<'FontName',MSVFORMFONT>
%        -\infty                                            %<'FontName',MSVFORMFONT>
%  
%  Fouriertransformierte von  {\fontname{Courier}s}  (sofern sie existiert).
%
%  {\fontname{Courier}S}  ist eine zu  {\fontname{Courier}s}  quivalente Darstellung des Signals. 
%
%  Wir benutzen die MATLAB-Funktion fourierplot zur symbolischen 
%  Ermittlung der Fouriertransformierten und ihrer 3D-Darstellung. 
%
%  Zunchst nur eine Demonstration mit drei einfachen Funktionen:
%
%%  Um den Verlauf zu erkennen muss man das Bild mit der Maus drehen. 
%%  Hilfe zum Bild gibt es mit der Taste h.
%%  Bitte etwas Geduld. Das rechnet eine Weile...
%
syms t w; A=fourierplot('exp(-t^2)*sin(t)',t,w,[-5,5],[-10,10])   % ungerade Funktion
%
syms t f; B=fourierplot('exp(-t^2)*cos(2*t)',t,w,[-5,5],[-10,10]) % gerade Funktion
%
syms t f; C=fourierplot('exp(-t^2)*(sin(t)+2*cos(2*t))',t,w,[-5,5],[-10,10]) % keine Symmetrie
%
%  Nun wird die eben ermittelte Fouriertransformierte mit der inversen 
%  Fouriertransformation in den Zeitbereich zurcktransformiert:
%
c = ifourierplot(C,w,t,[-10,10],[-5,5])                           % Rcktransformation
%
%  Der symbolische Funktionsausdruck ist quivalent und der Funktionsverlauf identisch 
%%  (bitte berprfen durch wechselseitiges Anklicken der beiden Bilder "Funktion").
%
%  Als Spektrum wird der Absolutbetrag der Fouriertransformierten bezeichnet.
%
%  Wir merken uns (hier ohne Herleitung):
%
%  Ein periodisches Zeitsignal mit der Periode  {\fontname{Courier}T}  hat ein diskretes Spektrum 
%  mit nichtverschwindenden Werten bei  {\fontname{Courier}f = k/T}  ({\fontname{Courier}k}  ganz).
%
%  Ein zeitdiskretes (digitales!) Signal mit den Abtastzeitpunkten  {\fontname{Courier}nT}  ({\fontname{Courier}n}  ganz) 
%  hat ein periodisches Spektrum mit der Periode  {\fontname{Courier}f_s = 1/T} .
%  {\fontname{Courier}f_s} heisst Abtastfrequenz (sample frequency).
%
%
%  Wir ermitteln jetzt die Fouriertransformierte der Funktion   {\fontname{Courier}cos(2\pif_0t)} ,  
%  wo  {\fontname{Courier}f_0 = 3.0}  die Frequenz bedeutet.  
%
syms t,w; f0=3.0; ft=fourierplot(cos(2*pi*f0*t),t,w); 
expand(ft)
%
%%  Aufgabe 1.1:  Der Ausdruck der Fouriertransformierten hat zwei Terme. 
%%  Berechnen Sie die Zeitfunktion fr jeden der beiden Terme getrennt durch 
%%  inverse Fouriertransformation. 
%%  Setzen Sie den Ausdruck der Fouriertransformierten in Stringquotes  ' . . . '  
%%  (Das Problem, alle Funktionen einschliesslich der Distributionen gleichzeitig 
%%  symbolisch und numerisch zu behandeln, ist noch nicht zufriedenstellend gelst).  
%%
%%  Aus welchen Komponenten setzt sich also jede reelle Sinus- bzw. Kosinus-Schwingung 
%%  zusammen? 
%%  Worin besteht der Unterschied der beiden Komponenten im Zeitbereich? 
%%  Betrachten Sie jeweils den Realteil ber  t  und den Imaginrteil ber  t.
%%
%%  Arbeiten Sie jetzt direkt im Kommandofenster!
%
help ifourierplot
%
