%
%
% Versuch 3:  Datenbertragung im Basisband%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE-16,'Color',MSVTITLCOLOR>
%
%
%
%  Die zu bertragende Information sei reprsentiert als Sequenz von Symbolen aus 
%  einer endlichen Symbolmenge von reellen Zahlen.  Beispiele fr Symbolmengen sind:
%  {\fontname{Courier}\{0, 1\},  \{-1, +1\},  \{-1.5, -0.5, +0.5, +1.5\}}.
%  Die Symbole werden bertragen zu festen quidistanten Zeitpunkten  {\fontname{Courier}t_n} .  
%  Den Abstand der Zeitpunkte nennt man Schritt.  Daraus ergibt sich die  
%  {\fontname{Courier}Schrittfrequenz = 1/Schritt} .
%
%  Die physikalische Reprsentation der Symbole ist jedoch analog und zeitkontinuierlich.  
%  Reiht man rechteckfrmige Symbole von {\fontname{Courier}Schrittlnge}  aneinander (PCM), 
%  so ergibt sich ein Spektrum, das Frequenzmultiplex ausschliesst.  Wir betrachten 
%  ein einziges Symbol:
%
syms t f; 
D = fourierplot('-Heaviside(t-1/2)+Heaviside(t+1/2)',t,f,[-2,+2],[-100,+100])
a = get(findobj('Name','Funktion'),'children'); 
if iscell(a) set(a{1},'ylim',[-0.5,1.5]); else set(a(1),'ylim',[-0.5,1.5]); end
%
%  Und nun eine Bitsequenz: 
%
syms t f; 
D = fourierplot('-Heaviside(t-2)+Heaviside(t-1)-Heaviside(t-5)+Heaviside(t-4)-Heaviside(t-8)+Heaviside(t-6)',t,f,[0,10],[-50,50])
a = get(findobj('Name','Funktion'),'children');
if iscell(a) set(a{1},'ylim',[-0.5,1.5]); else set(a(1),'ylim',[-0.5,1.5]); end
%
%  Wird umgekehrt - fr Frequenzmultiplex optimal - ein rechteckfrmiges Spektrum 
%  verlangt, so ergibt sich durch inverse Fouriertransformation ein zeitlich unendlich 
%  ausgedehntes Symbol, was ebenfalls unbrauchbar ist.
%
%  Es gibt zwei Methoden, anstelle des Treppensignals ein Signal zu erzeugen, 
%  dessen Frequenzanteile oberhalb einer Grenze, z.B.  {\fontname{Courier}2*Schrittfrequenz} , 
%  auf nicht mehr strende Amplituden gedmpft sind:
%
%  (1)  Die reellen Symbolwerte werden als Sttzstellen fr eine geeignete 
%        Interpolation verwendet.
%
%  (2)  Das Signal, welches an den Schrittzeitpunkten aus  {\fontname{Courier}Symbolwert*Deltafunktion} 
%        besteht und sonst verschwindet, wird durch ein Tiefpassfilter mit entsprechender 
%        oberer Grenze gefiltert, d.h. die strenden Anteile werden durch Filtern beseitigt.
%
%  \bfMethode (1):  Interpolation
%
%  Als wichtige Verfahren zu Methode (1) betrachten wir:
%  (1a) die Verbindung der Symbolwerte durch eine halbe Cosinus-Schwingung 
%  (sog. Raised Cosine)  und
%  (1b) die Shannoninterpolation.  Hier wird durch jeden Symbolwert  {\fontname{Courier}s_n}  zum 
%  Abtastzeitpunkt  {\fontname{Courier}t_n}  die Funktion  
%  {\fontname{Courier}s_nsin(\pif_s(t-t_n)) / \pif_s(t-t_n)}
%
%  gelegt.  Alle anderen dieser Funktionen verschwinden am Zeitpunkt  {\fontname{Courier}t_n} .  
%  Die Summe aller Funktionen ergibt die interpolierte Funktion.  Das Spektrum des so 
%  erzeugten zeitkontinuierlichen Signals stimmt im Bereich   {\fontname{Courier}-f_s/2 .. +f_s/2}  
%  mit dem des zeitdiskreten berein, verschwindet aber ausserhalb.
%
%  Ein Beispiel fr Raised Cosine bzw. fr die Shannon-Interpolation 
%  mit 16 zuflligen Bits gibt:
%
bits = randx(16,-1:2:+1);
raisedcosine(bits,10);
nyquistinterpol(bits);
%
%%  Aufgabe 3.1  
%%  Benutzen Sie nun die beiden folgenden Funktionen  {\fontname{Courier}rcspectrum} 
%%  und  {\fontname{Courier}nqispectrum} , um die Spektren kurzer zuflliger Sequenzen 
%%  numerisch zu berechnen:
%
help rcspectrum
%
help nqispectrum
%
%%  Bestimmen Sie fr beide Interpolationsverfahren, an welcher Stelle das Spektrum 
%%  auf  0.01*Maximalwert gefallen ist und runden sie diesen Wert auf  0.0  0.5  1.0  1.5 ...
%%  Nehmen Sie in beiden Fllen vor der Rundung den Mittelwert von wenigstens je drei 
%%  Versuchen.  Nutzen Sie die Mglichkeit der logarithmischen Skalierung mit der Taste y.
%%  Durch Eingabe von  "grid on"  ins Kommandofenster lsst sich ein Gitter einblenden.
%%  Drcken der linken Maustaste zeigt die Mausposition in Achseneinheiten.
%
rcspectrum
%
nqispectrum
%
%%  Welche Interpolation wrden Sie nehmen, wenn Bandbreite teuer ist (UMTS-Lizenzen!)?
%%  Was wird damit im Zeitbereich erkauft?  Zur Beantwortung dieser Frage betrachten 
%%  Sie einen einzigen von Null verschiedenen Impuls:
%
bits = [0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0];
raisedcosine(bits,10);
nyquistinterpol(bits);
delete(gcf)
%
%
%Die folgende Aufgabe ist optional!%<'FontWeight',MSVTITLWEIGHT,'FontSize',28,'Color','g'>
%
%Zunchst bitte weiter mit Kap. 4%<'FontWeight',MSVTITLWEIGHT,'FontSize',28,'Color','g'>
%
%
%  \bfMethode (2):  Filterung
%
%  Der Sender benutzt zur spektralen Begrenzung ein Filter. Der Empfnger 
%  setzt ein weiteres Filter ein zur Begrenzung des breitbandigen Rauschens. 
%  Das Sendefilter allein bestimmt das Spektrum der Aussendung.  Beide Filter 
%  zusammen formen die Datenpulse am Ort der Datenentscheidung.  Beim Entwurf
%  dieser Filter sind mehrere Punkte zu beachten.  Zwei davon sollen hier 
%  behandelt werden:
%
%  (a) Die Datenpulse sollen am Ort der Datenentscheidung, also nach beiden 
%  Filtern, Nullstellen an allen Abtastpukten der benachbarten Symbole haben, 
%  da sonst die Datenentscheidung fr ein Symbol von den aktuellen Nachbarn
%  abhngen wrde (sog. Intersymbolinterferenz).
%
%  (b) Der fr eine richtige Datenentscheidung zulssige Synchronisierungsfehler 
%  soll mglichst gross sein.
%
%  Beide Eigenschaften sind im sog. Augendiagramm abzulesen.  Dieses Diagramm 
%  entsteht aus dem (hier strungsfreien) Empfangssignal durch synchrones 
%  bereinanderschreiben im Schritttakt.  Intersymbolinterferenz macht sich 
%  dadurch bemerkbar, dass sich die Linien zum Zeitpunkt der Datenentscheidung 
%  nicht alle an den Symbolwerten schneiden.  Der mgliche Synchronisierungsfehler 
%  ergibt sich als halbe Breite der "Augenffnung".
%
%  Hier drei Beispiele:
%  Gezeigt werden jeweils sechs Bilder:
%    1. Frequenzgang der Filter
%    2. Sendepuls (also nach dem Sendefilter)
%    3. Impuls nach dem Empfangsfilter (also nach beiden)
%    4. Augendiagramm
%    5. Signale fr eine zufllige Bitsequenz
%    6. Spektrum der Aussendung
%
% Intersymbolinterferenz:   nein;   mglicher Synchronisationsfehler:  0.44:
%
filtererzeugung
txrxfilter(b{1},b{1})     
% 
% Intersymbolinterferenz:   ja;     mglicher Synchronisationsfehler:  0.48:
%
txrxfilter(b{2},b{2})     
% 
%%  Aufgabe 3.2:  Im Folgenden werden einige Filter als Sende und Empfangsfilter angeboten.  
%%  Ermitteln Sie jeweils die beiden Werte.  Vergrssern Sie dazu das Augendiagramm auf 
%%  Vollbild und geben Sie  "grid on"  ins Kommandofenster.
%%  Bestimmen Sie auch den maximalen Wert des Spektrums im Bereich  
%%  2.0 ... 5.0 * Schrittfrequenz.  Anschliessend klicken Sie auf  "filterdlg" . 
%%  Geben Sie dort in das Dialogfenster jeweils vier Zahlen ein, z.B.  1  0  0.44  0.012
%%  Erste  Zahl:   Nummer der Filterkombination
%%  Zweite Zahl:   0 (1) fr Intersymbolinterferenz nein (ja)
%%  Dritte Zahl:   maximal zulssiger Synchronisationsfehler (+-0.01)
%%  Vierte Zahl:   Maximaler Wert des Spektrums
%
txrxfilter(f{1},f{1}); % Filterkombination  1
%
txrxfilter(f{2},f{2}); % Filterkombination  2
%
txrxfilter(f{3},f{3}); % Filterkombination  3
%
txrxfilter(f{1},f{2}); % Filterkombination  4
%
txrxfilter(f{1},f{3}); % Filterkombination  5
%
txrxfilter(f{2},f{3}); % Filterkombination  6
%
filterdlg
%
