%
%
% Versuch 4:  Schrittsynchronisation%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE-10,'Color',MSVTITLCOLOR>
%
%
%
%  Auf der Empfngerseite ist das analoge Signal zu interpretieren.  Dazu ist zweierlei ntig:
%  
%  1.  Eine Rekonstruktion der Zeitpunkte, an denen die digitalen Daten abzutasten sind.
%
%  2.  Die Abtastung und Quantisierung (sog. Datenentscheidung)
%
%  Dieser Versuch gilt dem ersten Punkt.
%
%  Man unterscheidet zwei Verfahren zur Bestimmung der Abtastpunkte:
%
%  a.  Das {\bfStart/Stopp-Verfahren}:  Sender und Empfnger benutzen unsynchonisierte 
%       Uhren, die bis zu einer im Versuch zu bestimmenden Grenze unterschiedlich 
%       laufen drfen.  Die Abtastpunkte fr eine kurze Sequenz von Bits werden 
%       allein durch den Zeitpunkt des ersten sog. Start-Bits festgelegt.
%
%  b.  Der Empfnger synchronisiert seine Uhr durch {\bfRekonstruktion} aus dem 
%       empfangenen Signal.
%
%  Wir betrachten zuerst das Start/Stopp-Verfahren.  Dieses wird simuliert durch 
%  die Funktion  {\fontname{Courier}startstop} :
%
help startstop
%
%%  Versuch 4.1:  Bestimmen Sie, in welchem Bereich sich die Empfnger-Uhr bewegen 
%%  darf, wenn die Sender-Uhr auf 100 Zeitschritte pro Bit eingestellt wird.
%%
%%  Nun im Kommandofenster z.B. eingeben: 
%  startstop( 100, 102.3, [1 0 1 0 1 0 1 0]);  %<'FontName',MSVFORMFONT>
%
%%  Sie sollten besser gleich 4 Bytes eintragen und  {\fontname{Courier}rxschritt}  variieren.
%
sendbits  = [1 0 1 0 1 0 1 0 1 0 1 0 1 0 1 0 ];
recbits   = startstop( 100, 102.3, sendbits);
bitfehler = sum(recbits~=sendbits)
%
%
%
%Die folgende Aufgabe ist optional!%<'FontWeight',MSVTITLWEIGHT,'FontSize',28,'Color','g'>
%
%Zunchst bitte weiter mit Kap. 5%<'FontWeight',MSVTITLWEIGHT,'FontSize',28,'Color','g'>
%
%
%
%
%  b.  Der Empfnger synchronisiert seine Uhr durch Rekonstruktion aus dem 
%       empfangenen Signal.
%
%  Wir gehen aus von binren Raised-Cosine-Signalen mit den Symbolen {\fontname{Courier}\{-1, +1\}} . 
%  Das Quadrat eines solchen Signals hat bei jedem Wechsel zwischen den beiden 
%  Symbolen die Form   {\fontname{Courier}(cos(2\pif_rt) + 1)/2} .  Das Spektrum des Signalquadrates 
%  hat deshalb ein Maximum bei der Schrittfrequenz  {\fontname{Courier}f_r} .  Diese kann also aus 
%  dem Signalquadrat rekonstruiert werden, sofern Symbolwechsel vorkommen.
%
%  Die Funktion  {\fontname{Courier}schrittsync}  fhrt diese Rekonstruktion nach der Methode der 
%  kleinsten Quadrate durch.  Es werden dabei die Parameter  {\fontname{Courier}c, a, f_r, p}  der Funktion
%  c + acos(2\pif_rt + p)  %<'FontName',MSVFORMFONT>
%
%  so variiert, dass der euklidische Abstand zum Signalquadrat minimal wird.  Nur die 
%  Schrittfrequenz  {\fontname{Courier}f_r}  und die Phase  {\fontname{Courier}p}  werden davon bentigt.
%
help schrittsync
%
%%  Versuch 4.2:  Es sind durch Aufrufe von  schrittsync  mit verschiedenen Bitmustern 
%%  der Lnge  20  Antworten auf folgende Fragen zu finden:
%%  a.  Ist das Maximum im Spektrum des Signalquadrates absolut oder lokal?
%%  b.  Sind die Maxima unterhalb bzw. oberhalb der Schrittfrequenz verursacht 
%%       durch Rauschen oder spezielle Bitmuster?
%%
%%  Zufllige Muster knnen generiert werden mit 
%  randb(Anzahl,[-1,+1])   %<'FontName',MSVFORMFONT>
%
%%  Achten Sie darauf, dass alle Muster nur die Symbole  {\fontname{Courier}\{-1,+1\}}  benutzen. 
%%  Setzen Sie folgende Parameter:  
%  neutral = 1 ;   tol = 0.1;     %<'FontName',MSVFORMFONT>
%
schrittsync( 100, 102.3, randb(20,[-1 +1]), 0.4, 1, 0.1);
%
%%  Versuch 4.3:  Wiederholen Sie Versuch 4.2 unter Einsatz des Bitstuffing.  
%%  Verwenden Sie hierbei die Funktion  bitstuffing  oder/und geeignete Bitmuster wie z.B.
%  2*[1 1 0 0 1 1 0 0 1 1 0 0 1 1 0 0 1 1 0 0 1 1 0 0 1 1] - 1    %<'FontName',MSVFORMFONT>
%
%%  Folgende Fragen sind zu beantworten:
%%  c.  Wird das Maximum des Spektrums an der Schrittfrequenz deutlicher?
%%  d.  Werden andere Maxima geschwcht oder gar krftiger?
%
help bitstuffing
%
%%  Die folgenden Aufrufe testen das Verhalten unter sehr starkem Rauschen. 
%%  Im Kommandofenster wird die Zahl der Bitfehler angegeben, und zwar:   
%%  syncfehler = Anzahl der durch Synchronisation verursachten Bitfehler
%%  bitfehler   = Anzahl aller Bitfehler (mit Empfangsfilter).
%
sendbits  = bitstuffing(0,3,randx(20,[-1 +1]),[-1,+1]);
[s,r0,r1] = schrittsync( 100, 102.3, sendbits, 1.0, 1, 0.1);
syncfehler= sum(r0~=sendbits)
bitfehler = sum(r1~=sendbits)
%
sendbits  = 2*[1 1 1 0 0 0 1 1 1 0 0 0 1 1 1 0 0 0 1 1 1 0 0 0 1 1 1]-1;
[s r0,r1] = schrittsync( 100, 102.3, sendbits, 1.0, 1, 0.1);
syncfehler= sum(r0~=sendbits)
bitfehler = sum(r1~=sendbits)
%
%  {\bfHinweis}: In der Praxis ist die Schrittfrequenz sehr viel genauer bekannt als die 
%  hier angenommenen  {\fontname{Courier}10%} .  Dann gelingt die Schrittsynchronisation auch bei stark 
%  verrauschten Signalen wesentlich sicherer.
%