%
%
%Versuch 5:  Modulation%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE-10,'Color',MSVTITLCOLOR>
%
%
% Pflicht sind die Versuche  5.1,  5.3,  5.4 .%<'FontWeight',MSVTITLWEIGHT,'FontSize',20,'Color','g'>
%
% Vorangestellt ist ein Lehrtext zu Modulationsarten, %<'FontWeight',MSVTITLWEIGHT,'FontSize',20,'Color','g'>
% dessen Inhalt bekannt sein sollte!%<'FontWeight',MSVTITLWEIGHT,'FontSize',20,'Color','g'>
%
%
%  \bfModulationsarten
%
%  Im Basisband ist Frequenzmultiplex nicht mglich.  Die Verschiebung des 
%  Basisbandsignals  {\fontname{Courier}b(t)}  in ein hheres Frequenzband erfolgt durch Modulation. 
%  Es gibt drei Modulationsarten und eine Reihe von Varianten und Kombinationen. 
%  Sie sind alle zurckzufhren auf das Signal
%  s(t) = a(t) cos(2\pif(t)t + p(t))                  %<'FontName',MSVFORMFONT>
%
%  \bfAmplitudenmodulation (AM):
%  {\fontname{Courier}f(t) = f_0} (Trgerfrequenz)  und  {\fontname{Courier}p(t) = p_0}   sind konstant.
%  Die Information  {\fontname{Courier}b(t)}  wird in  {\fontname{Courier}a(t)}  reprsentiert.
%  Man unterscheidet zwei Methoden der Erzeugung von  {\fontname{Courier}a(t)} aus dem 
%  Basisbandsignal  {\fontname{Courier}-1 < b(t) < +1} :
%  1.    a(t) = 1 + b(t)    AM-Rundfunk (LW,MW,KW)   %<'FontName',MSVFORMFONT>
%  2.    a(t) = b(t)                                 %<'FontName',MSVFORMFONT>
%
%  Bei  {\fontname{Courier}1.}  wird der grsste Teil der Sendeleistung zur Aussendung der 
%  Trgerschwingung verbraucht.  Bei  {\fontname{Courier}2.}  wird kein Trger gesendet. 
%  Er muss aber fr die Demodulation im Empfnger rekonstruiert werden.
%
%  \bfPhasenmodulation (PM):
%  {\fontname{Courier}a(t) = a_0}  und  {\fontname{Courier}f(t) = f_0} (Trgerfrequenz) sind konstant. 
%  Die Information wird in  {\fontname{Courier}p(t)}  reprsentiert, z.B.
%  {\fontname{Courier}p(t) = \pib(t)} ,  wo  {\fontname{Courier}-1 < b(t) < +1} .
%
%  \bfFrequenzmodulation (FM):
%  FM ist eine Phasenmodulation mit dem Integral des Basisbandsignals  {\fontname{Courier}b(t)} :
%                           t                                         %<'FontName',MSVFORMFONT>
%  s(t) = a_0 cos(2\pif_0t + 2\pim _{\fontsize{24}\int} b(\tau) d\tau + p_0) %<'FontName',MSVFORMFONT>
%                          -\infty                                    %<'FontName',MSVFORMFONT>
%
%  Die aktuelle Frequenz des Cosinus ergibt sich durch Differentiation des Cosinus-
%  Arguments nach  {\fontname{Courier}t}  und Division durch  {\fontname{Courier}2\pi} :
%  f = f_0 + mb(t)    %<'FontName',MSVFORMFONT>
%
%  Der Ausdruck macht klar, warum man von Frequenzmodulation spricht.  Auch bei 
%  konstantem nicht verschwindendem  {\fontname{Courier}b(t)}  sind  {\fontname{Courier}f} und  {\fontname{Courier}f_0}  verschieden im 
%  Gegensatz zu PM.  Die Demodulation von FM erfolgt durch zeitliche Differentiation 
%  der Ausgabe des Phasendemodulators.  Wegen dieser Ableitung fllt der konstante 
%  Phasenterm  {\fontname{Courier}p_0}  weg.  Auch ist die genaue Kenntnis von {\fontname{Courier}f_0}  beim FM-Empfnger 
%  nicht erforderlich.  Nachrichtentechnisch ist FM wegen der Empfindlichkeit der 
%  Differentiation bei Strungen wesentlich schlechter als PM.  Die notwendige 
%  Rekonstruktion der Trgerschwingung macht allerdings den PM-Demodulator 
%  deutlich aufwendiger.
%
%  Bei AM gibt es noch die wichtige Variante der Quadratur-Amplitudenmodulation (QAM). 
%  Dies ist eine Kombination von AM und PM die durch Separation von  {\fontname{Courier}s(t)} in 
%  {\fontname{Courier}cos-}  und  {\fontname{Courier}sin-}Anteil entsteht:
%
%  s(t) = a_c(t) cos(2\pif_0t) + a_s(t) sin(2\pif_0t)   %<'FontName',MSVFORMFONT>
%
%  Hieraus ergibt sich durch Transformation von kartesischen in Polarkoordinaten:
%  a(t) = sqrt(a_c(t)^2 + a_s(t)^2)   %<'FontName',MSVFORMFONT>
%  p(t) = arctan(a_s(t)/a_c(t))       %<'FontName',MSVFORMFONT>
%
%  Mit  {\fontname{Courier}a_c(t)}  und  {\fontname{Courier}a_s(t)}  kann man gleichzeitig zwei verschiedene Signale 
%  auf der selben Trgerfrequenz modulieren.
%
%
%  Die Funktion  {\fontname{Courier}modulation}  demonstriert die Modulationsarten: 
%
modulation
%
%  Die Spektren der Modulationsarten belegen ein Frequenzband beiderseits der 
%  Trgerfrequenz  {\fontname{Courier}f_0} .  Wir demonstrieren dies fr den Fall AM mit einem 
%  Nyquistpuls  {\fontname{Courier}sin(at)/(at)}  und folgenden Konstanten:
%
ftr = 2.5;    % Trgerfrequenz
b   = 0.4;    % Breite des Frequenzbandes
a   = pi*b;   % Pulskonstante: halbe Breite des Frequenzbandes in w 
syms  t w;    % symbolische Variable 
A = fourierplot(cos(2*pi*ftr*t)*sin(a*t)/(a*t),t,w,(10/a)*[-1,1],4*pi*ftr*[-1,1])
%
%%  Versuch 5.1:  Beantworten Sie zu der symbolisch berechneten Fouriertransformierten 
%%  die Fragen:
%%
%%  1.  Es wird die Trgerfrequenz  f0 = 2.5  mit dem Nyquistpuls in der Amplitude 
%%       moduliert.  Erklren Sie, warum die Fouriertransformierte in ZWEI Bereichen 
%%       symmetrisch zu   w = 0   von Null verschieden ist.
%%
%%  2.  Die Trgerfrequenz ist  f0 = 2.5 .  Warum liegt der von Null verschiedene 
%%       Bereich bei  14.4513 < w < 16.9646 ? 
%
%  Der ideale Nyquistpuls ist wegen seiner zeitlichen Ausdehnung unbrauchbar. 
%  Nachfolgend wird deshalb Raised Cosine benutzt.
%
%Der folgende Versuch 5.2 ist optional!%<'FontWeight',MSVTITLWEIGHT,'FontSize',22,'Color','g'>
%
%Zunchst bitte weiter mit "Digitale Modulation"%<'FontWeight',MSVTITLWEIGHT,'FontSize',22,'Color','g'>
%
%%  Versuch 5.2:  Ermitteln Sie, welche Modulationsarten bei gleichem Basisbandsignal 
%%  beidersets des Trgers schneller verschwinden.
%%
%%  Rufen Sie hierzu mehrfach die Funktion  modspec  auf, die ein zuflliges 
%%  Basisbandsignal erzeugt und das Spektrum numerisch ermittelt. 
%%  Nutzen Sie die logarithmische Skalierung mit der Taste y.
%
modspec
%
%
%  \bfDigitale Modulation
%
%  Unter digitaler Modulation versteht man die Modulation mit digitaler Information. 
%  In diesem Fall benutzt man folgende Bezeichnungen:
%  Amplitude Shift Keying (ASK) anstelle von AM
%  Frequency Shift Keying (FSK) anstelle von FM
%  Phase Shift Keying (PSK) anstelle von PM.
%  Darber hinaus stellt man hufig die benutzte Anzahl von Niveaus voran:
%  2-ASK, 2-FSK, 2-PSK, 4-ASK, 4-FSK, 4-PSK, 8-ASK usw.
%  Bei QAM wie auch bei anderen ASK/PSK-Kombinationen gilt die vorangestellte Zahl 
%  fr die Anzahl aller Symbole.  Sind z.B. beide Basisbandsignale bei QAM binr, 
%  so ergibt das eine  4-QAM.  Anstelle von 2-PSK und 4-PSK wird hufig BPSK bzw.
%  QPSK geschrieben.
%
%  Der Empfnger muss zunchst aus dem reellen Empfangs-Signal das komplexe 
%  Basisbandsignal erzeugen: 
%  Durch Multiplikation mit  {\fontname{Courier}cos(2\pif_0t)}  ergibt sich der Realteil,
%  durch Multiplikation mit  {\fontname{Courier}-isin(2\pif_0t)}  der Imaginrteil.
%  Beide Teile werden anschliessend gefiltert (Empfangsfilter).  QAM ist damit schon 
%  demoduliert.  Bei AM, PM und FM ist noch nach Polarkoordinaten zu transformieren.
%
%  Ist die Eingangsfrequenz des Empfngers  {\fontname{Courier}f} , so dreht sich das Signal in der 
%  komplexen Ebene mit der Frequenz  {\fontname{Courier}f - f_0} .  Ist  {\fontname{Courier}f < f_0} , so ist 
%  die Drehung rckwrts (in Richtung der positiven Zeitachse gesehen linksherum).
%
%%  Versuch 5.3:  FSK-Modem nach V.21 mit Start/Stopp-Synchronisation.
%%  Die Funktion  v21startstop  liefert die komplexe Ebene des modulierten Basisband-
%%  Signals als zeitliche Animation. Ausserdem wird das modulierte Emfangssignal ber 
%%  die Soundkarte ausgegeben.  Das 3D-Bild ist danach mit der Maus drehbar. 
%%  Die Sichtbarkeit der grafischen Objekte ist mit den Tasten  0, 1, 2, 3, 4, 5, 6 
%%  ein- und auszuschalten.  Objekt  0  ist ein Cursor, der mit den Tasten  +  bzw.  -  um je 
%%  einen Abtastschritt bewegt werden kann.
%%
%%  Die Spezifikation von  V.21  (eine Richtung) ist wie folgt:
%%               Trgerfrequenz  :   1080 Hz                     %<'FontName',MSVFORMFONT>
%%               Schrittfrequenz :    300 Baud                   %<'FontName',MSVFORMFONT>
%%               Modulation :         FSK                        %<'FontName',MSVFORMFONT>
%%               Symbole :            980 Hz reprsentiert "1"   %<'FontName',MSVFORMFONT>
%%                                   1180 Hz reprsentiert "0"   %<'FontName',MSVFORMFONT>
%%
%%  Die durch blaue Punkte markierte Abtastfrequenz in der Darstellung ist  1800 Hz.
%%
%%  Aufgabe: Die dargestellte Sequenz enthlt zwei Bytes nach dem Start/Stopp-Verfahren. 
%%  Die  16  Bit sind visuell aus dem Bild zu entnehmen und anschliessend einzugeben.
%%
%%  Hinweis:     Die Bits knnen im Basisband am besten aus der Rotationsrichtung 
%%                       abgelesen werden bei Blick in Zeitrichtung, d.h. auf die Kreisrotation.
%%                       Tippen Sie die Taste  0  um einen grnen Cursor auf der Kurve zu erhalten. 
%%                       Ein Cursorschritt ist ein Abtastschritt von  1/1800  Sekunde.
%
bits = bitstuffing(0,3,randb(16)); bits = bits(1:16);
v21startstop(bits);
%
%%  Haben Sie die 16 Bits ermittelt?  Dann klicken Sie hier und geben die Bits in der Form 
%%  001011 . . .  in das erscheinende Dialogfenster.  Eine Antwort erscheint im Kommandofenster.
%
instr = inputdlg('','16 Bits eingeben wie 11010001...');
invec = instr{1}=='1';
lenok = length(invec)==16;
if ~lenok  '!!! Es mssen 16 Bits sein !!!', end
if lenok  b1 = sum(invec(1:8)~=bits(1:8)); b2 = sum(invec(9:16)~=bits(9:16)); end
if lenok antwort = sprintf('  %d Bits im ersten und %d Bits im zweiten Byte sind falsch',b1,b2); end
if lenok if (b1+b2>0)  antwort, else  'o.k !', end; end
%
%
%%  Versuch 5.4:  Ein ASCII-Text wird nach  V.21  (300 Baud FSK) mit Start/Stopp-
%%  Synchronisation ber die Soundkarte ausgegeben und via Mikrofon mit dem 
%%  Audiorecorder aufgezeichnet.  Nach manueller Bearbeitung der Aufnahme wird 
%%  diese in MATLAB dem FSK-Empfnger zugefhrt und ausgewertet.
%%
%%  Das gleichzeitige Ausgeben und Aufnehmen funktioniert leider nur mit besseren 
%%  Soundkarten. Fhren Sie deshalb diesen Versuch gemeinsam mit einer anderen 
%%  Praktikumsgruppe aus.
%%
%%  Schliessen Sie Lautsprecher und Mikrofon an und berprfen Sie deren Funktion 
%%  und Pegel.
%%
%%  Zuerst ist der zu sendende Text einzugeben.  Das Eingabefenster erscheint nach 
%%  Klick auf folgendes Kommando:
%
tcel = inputdlg('(maximal 32 Zeichen)','Eingabe: Zu sendender Text');
txt  = tcel{1};          % 
bits = str2binvec(txt);  % ASCII nach Bitvektor
%
%%  Es sind nun die Einstellungen fr die Audioaufnahme (Mikrofon) und fr die 
%%  Ausgabe so einzustellen, dass der Pegel bei der Aufnahme im richtigen Bereich 
%%  liegt.  ffnen Sie im Audiorecorder eine neue Datei und klicken Sie dort im 
%%  Men "Eigenschaften" und anschliessend "Umwandeln".  Stellen Sie  "Format"  PCM 
%%  und  "Attribute"  8.000 Hz ;  16 Bit ;  Mono   ein und besttigen Sie mit "ok".
%% 
%%  Die Aufnahme mit dem Audiorecorder ist nun zu starten und sofort anschliessend 
%%  die folgende Kommandosequenz zu klicken um den Text zu senden.
%
fs   = 8000;             % Abtastrate 8 kHz
flr  = fsktest(10000,1080/fs,300/fs,100/fs,bits);
%
%%  Stoppen Sie nun den Audiorecorder.
%
%%  Prfen Sie die Aufnahme mit dem Audiorecorder visuell und akustisch, ob der 
%%  Pegel richtig liegt.  Wiederholen Sie die Aufnahme, falls etwas nicht stimmt.
%
%%  In der Audioaufnahme ist nun der Signal-freie Anfang sowie das Ende vollstndig 
%%  wegzuschneiden.  Der Audiorecorder bietet hierfr im Men "Bearbeiten" die 
%%  passenden Funktionen.  Das Resultat ist nun unter dem fest vorgegebenen Dateinamen 
%%  "v21.wav"  zu speichern.
%%
%%  Die Datei  "v21.wav"  wird nun in MATLAB eingelesen und das Signal im FSK-Empfnger 
%%  ausgewertet und dargestellt:
%
s = wavreadx('v21.wav');                    % Lesen der *.wav-Datei
recbits = fskrx(s',1080/fs,300/fs,300/fs,1) % FSK-Empfnger
rectext = binvec2str(recbits);              % empfangener Text
%
%%  Das Bild Binrsignal kann mit den Tasten  g  k  +  -   vergrssert, verkleinert und 
%%  gerollt werden.  Das Bild Kompexsignal lsst sich mit der Maus drehen.  Das Lschen 
%%  des Bildes dauert SEHR lange!
%%
%%  Darstellung des empfangenen Textes:
%
fh = fullscreen('Telegramm'); set(fh,'Position',[2 576 1019 171]);
axis([0 1,0 1]); set(gca,'visible','off')
text(-0.06,0.5,rectext,'FontSize',35,'Color','r')
if length(recbits)~=length(bits) 'Anzahl der empfangenen Bits ist falsch', end
if length(recbits)==length(bits) bitfehler = sum(recbits~=bits), end
%
%  Bei der Datenbertragung per Audiosignal durch Luft ist zu beachten, dass 
%  die Wellenlnge bei  {\fontname{Courier}1 kHz}  nur  {\fontname{Courier}34 cm}  betrgt.  Schon bei der bertragung 
%  ber kurze Strecken kann es zu Reflexionen und damit zu Fadingeffekten kommen.  
%  Viel problematischer ist die Intersymbolinterferenz bei Wegunterschieden in der 
%  Grssenordnung der Schrittlnge (und mehr).  Die Schrittlnge betrgt bei  
%  {\fontname{Courier}300 Baud}  in Luft  {\fontname{Courier}1.13 m} .
%
%
%Die folgenden Aufgaben sind optional!%<'FontWeight',MSVTITLWEIGHT,'FontSize',24,'Color','g'>
%
%Auch das folgende Kapitel 6 ist optional%<'FontWeight',MSVTITLWEIGHT,'FontSize',24,'Color','g'>
%
%
%  \bfMehrwertige digitale Modulation
%
%  Bei FSK wird zu den mit der Schrittsynchronisation ermittelten Zeitpunkten 
%  die Winkelgeschwindigkeit in der komplexen Ebene ermittelt. Anstelle zweier 
%  Symbole "Vorwrtsdrehung" und "Rckwrtsdrehung" knnen auch mehrere z.B. 
%  {\fontname{Courier}4} Geschwindigkeiten vorgesehen werden (mehrwertige FSK).
%
%  Im Falle von ASK, PSK oder QAM sind zu den mit der Schrittsynchronisation 
%  ermittelten Zeitpunkten Realteil und Imaginrteil direkt abzutasten. 
%  Der abgetastete Punkt in der komplexen Ebene ist nun einem der komplexen 
%  Symbole zuzuordnen.
%
%  Beachten Sie, dass immer ein reelles Signal bertragen wird.  Das komplexe 
%  Signal im Basisband wird bei allen Modulationsarten im Empfnger aus dem 
%  reellen Empfangssignal durch Multiplikation gewonnen mit 
%  e^{-i2\pif_0t} = cos(2\pif_0t) - i\cdotsin(2\pif_0t) ,  %<'FontName',MSVFORMFONT>
%
%  wo  {\fontname{Courier}f_0}  die Trgerfrequenz ist.
%
%  Die folgenden Bilder zeigen bliche Symbolanordnungen.  Dabei ist realistisches 
%  Rauschen hinzugefgt.  Alle heutigen Verfahren schalten je nach Kanalqualitt 
%  um zwischen verschiedenen Symbolanordnungen und bertragungsraten.  {\fontname{Courier}E_b/N_0}  
%  steht fr Energie pro Informationsbit dividiert durch Rauschenergie pro Bandbreite.
%
mpsk_noise(2,6)  % 2-PSK
%
v27bis;          % V.27bis:  8-PSK und 4-PSK
%
v29;             % V.29:     16-ASK/PSK, 8-ASK/PSK, 4-PSK
%
v22bis;          % V.22bis:  16-QAM und 4-PSK
%
%%  Versuch 5.5:  Geben Sie fr 8-PSK eine binre Codierung der Symbole an dergestalt, 
%%  dass ein Fehler bei der Entscheidung fr das Symbol fast immer nur einen Ein-Bit-Fehler 
%%  bewirkt.
%%
%%  Die acht dreistelligen Binrwrter sind mit Blank oder Komma getrennt einzugeben, z.B.  
%%  110  100  101  ... : 
%
instr = inputdlg('8  3-stellige Binrzahlen:','Codierung fr 8PSK');
invec = eval(strcat('[',instr{1},']'));
invc2 = [invec(length(invec)),invec(1:length(invec)-1)];
diff  = abs(invec - invc2);
isok  = all((diff==001)|(diff==010)|(diff==100))&(all(ismember([000 001 010 011 100 101 110 111],invec)));
if isok  'o.k. !', end
if ~isok  'das ist nicht korrekt', end
%
%
%%  Versuch 5.6:  Geben Sie fr die Symbole der 16-QAM eine binre Codierung an 
%%  dergestalt, dass ein Dekodierfehler fast immer nur einen Ein-Bit-Fehler bewirkt.
%%
%%  Die 4*4-Matrix von 4-stelligen Binrzahlen ist in der Form  
%%  0110 1110 1111 0111; 0010 0110 ... einzugeben. 
%%  Prfen Sie die Syntax bevor Sie OK klicken,  da Sie sonst alles noch einmal eingeben 
%%  mssen.  Achten Sie auf das korrekte Setzen der ";" .
%
incell = inputdlg('16  4-stellige Binrzahlen:','Codierung fr 16QAM');
instr  = incell{1};
%
%  Prfung auf Korrektheit (Antwort im Kommandofenster):
%
isok  = iseinschritt2d(eval(strcat('[',instr,']')));
if isok  'o.k. !', else 'das ist nicht korrekt', end
%
%%  Falls die Eingabe nicht richtig war, knnen Sie im Kommandofenster  instr  erfragen 
%%  und anschliessend  instr='....' mit Cut and Paste editieren
%
%  Die folgende Animation zeigt zufllig verteilte  16QAM-Symbole  in beiden Richtungen 
%  mit  raised-cosine  verbunden.  Das Bild kann nach der Animation mit der Maus gedreht 
%  werden.
%
n  = 8;
s  = v22bis(0,100);            % 100 16QAM-Symbole 
src = raisedcosine(s,n);       % Verbindung mit raised cosine
komplexanimat(src,[1 1 0 0 0 1],1,[90 0],1:n:length(src))
%
