%
%
%Versuch 6:  Kanalcodierung%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE-10,'Color',MSVTITLCOLOR>
%
%
%Dieses Kapitel ist optional!%<'FontWeight',MSVTITLWEIGHT,'FontSize',28,'Color','g'>
%
%
%  \bfa. Der {\fontname{Courier}(7,4)}-Hammingcode
%
%  Hammingcodes sind lineare Codes.  Die Codierung erfolgt durch Multiplikation des 
%  {\fontname{Courier}k}-stelligen Informationsvektors mit einer  {\fontname{Courier}n\timesk}-Codiermatrix.  Die Multiplikation 
%  erfolgt im endlichen Krper {\fontname{Courier}GF(q)} .  Im Fall des binren {\fontname{Courier}(7,4)}-Hammingcodes 
%  ist diese Matrix: 
%
A = [1 0 0 0; 0 1 0 0; 0 0 1 0; 0 0 0 1; 1 1 1 0; 0 1 1 1; 1 1 0 1]
% 
%%  Nach Klick hier ist die Matrix im Kommandofenster zu sehen und weiterverwendbar.
%
%  Dieser Code codiert jeweils Informationswrter von {\fontname{Courier}4} Bits in Codewrter der 
%  Lnge  {\fontname{Courier}7} Bits.  Hier zwei Beispiele, in denen jeweils die erforderliche 
%  Transponierung mit "'" erfolgt:
%
infowort = [1 0 1 1]
codewort = mod(A*infowort',2)'
%
infowort = [0 1 1 0]
codewort = mod(A*infowort',2)'
%
%  Die Modulo-Operation   {\fontname{Courier}mod(x*y,2)}   realisiert hier die Matrixmultiplikation 
%  im  {\fontname{Courier}GF(2)} .
%
%  Ein empfangenes Wort  {\fontname{Courier}empfwort}  kann Bitfehler enthalten.  Die Prfung auf 
%  Fehler erfolgt durch die Berechnung des Syndroms  {\fontname{Courier}s}  durch Matrixmultiplikation 
%  mit der Matrix 
%
H = [A(5:7,:),eye(3)]
%
%  Im Falle eines fehlerfreien Codewortes ist  {\fontname{Courier}s = 0} :
%
s = mod(H*codewort',2)'
%
%  Liegt ein Bitfehler vor, so gibt das Syndrom eindeutig die Position des Bitfehlers an.
%
%%  Aufgabe 6.1:  Finden Sie die Zuordnung zwischen Syndrom  s  und Position des Bitfehlers. 
%%  Codieren Sie hierzu ein  infowort  (z.B. [0 0 0 0]) , verflschen der Reihe nach jeweils 
%%  ein Bit und berechnen dann das Syndrom.  Das Ergebnis speichern Sie in dem Vektor fbit, 
%%  der dem Integer-Wert des Syndroms die Bitposition zuordnet.
%%
%%  Der Korrekturalgorithmus fr das empfangene Wort  empfwort  ist dann:
%  korrwort = empfwort;                                       %<'FontName',MSVFORMFONT>
%  if s>0  korrwort(fbit(s)) = xor(empfwort(fbit(s)),1); end  %<'FontName',MSVFORMFONT>
%%
%%  Prfen Sie Ihren Vektor fbit durch wenigstens  {\fontname{Courier}20}  Aufrufe des folgenden 
%%  Scripts:
%
infowort = randb(4)                % zufllige 4-Bit-Information
codewort = mod(A*infowort',2)'     % das zugehrige Codewort
empfwort = codewort;               % noch unverflscht
fehlrbit = ceil(7*rand)            % zu verflschende Bitstelle
empfwort(fehlrbit) = xor(empfwort(fehlrbit),1) % verflscht
sbinvect = mod(H*empfwort',2)'     % Syndrom-Bitvektor
sinteger = binvec2num(sbinvect)    % Syndrom-Index
korrwort = empfwort;  
if sinteger>0  korrwort(fbit(sinteger)) = xor(empfwort(fbit(sinteger)),1); end
korrinfo = korrwort(1:4)           % korrigierte Information
anzfehlr = sum(korrinfo~=infowort) % Anzahl Bitfehler nach Korrektur
%
%%  Aufgabe 6.2: Wie verhlt sich der Korrekturalgorithmus im Falle von r-Bitfehlern 
%%  (r = 0, 1, 2, 3) ?
%
%
%  \bfb. Statistik
%
%  Gegeben sei die Energie  {\fontname{Courier}E_s} , z.B. eine geladene Batterie.  Diese Energie 
%  soll zur bertragung von  {\fontname{Courier}k}  Informationsbits verwendet werden.  Fr jedes 
%  Informationsbit steht also die Energie  {\fontname{Courier}E_b = E_s/k}  zur Verfgung.  
%  Der Empfnger erhlt nur einen  Bruchteil  {\fontname{Courier}E_e = aE_s}  der gesendeten Energie. 
%  Er empfngt zustzlich ein strendes weisses Rauschen.  Dieses hat die Leistung  
%  {\fontname{Courier}N = N_0b} , wo  {\fontname{Courier}N_0}  die Leistung pro  {\fontname{Courier}Hz}  Bandbreite ist und  {\fontname{Courier}b}  die Bandbreite.
%
%  Die Wahrscheinlichkeit, dass alle  {\fontname{Courier}k}  Informationsbits korrekt am Empfangsort 
%  erhalten werden, ist zu maximieren.
%
%  Fr PSK lsst sich bei Verwendung geeigneter Filter die Bitfehlerwahrscheinlichkeit 
%  herleiten zu:
%  P_e = 0.5 erfc((E_b/N_0)^{1/2})  %<'FontName',MSVFORMFONT>
%
%  Dies gilt fr den direkten Empfang uncodierter Informationsbits.
%
%  Im Falle der Codierung von  {\fontname{Courier}k}  Informationsbits mit einem fehlerkorrigierenden 
%  {\fontname{Courier}(n,k)-}Code mssen anstelle der  {\fontname{Courier}k}  Informationsbits mit der selben zur Verfgung 
%  stehenden Gesamtenergie  {\fontname{Courier}kE_b}  nun  {\fontname{Courier}n}  Codewortbits bertragen werden.  
%  Man bezeichnet das Verhltnis
%  r = k/n                          %<'FontName',MSVFORMFONT>
%
%  als Coderate.
%
%  Bei codierter bertragung  gibt es zwei Methoden der Datenentscheidung und 
%  Decodierung:
%
%  (a)  Die Codewortbits werden entschieden.  Darauf erfolgt die digitale Decodierung 
%        mit mglicher Korrektur.
%
%  (b)  Das gesamte Codewort wird analog empfangen und mit den korrekten 
%        digitalen Codewrtern korreliert.  Die Datenentscheidung fllt aufgrund 
%        der grssten Korrelation.
%
%  Darberhinaus unterscheidet man die Codierung in Blcken von  {\fontname{Courier}k}  Informationsbits 
%  vom Codieren eines fortlaufenden Bitstromes von  {\fontname{Courier}K}  Informationsbits pro 
%  Sekunde in einen codierten Bitstrom von  {\fontname{Courier}N}  Bits pro Sekunde (sog. Faltungscodes).
%
%  Wir berechnen zunchst die Bitfehlerwahrscheinlichkeit nach der Decodierung fr den 
%  Fall (a) bei Blockcodes.  Die Bitfehlerwahrscheinlichkeit fr empfangene Bits ist
%  p = 0.5 erfc(((kE_b/nN_0)^{1/2})  %<'FontName',MSVFORMFONT>
%
%  Kann der {\fontname{Courier}(n,k)-}Code  {\fontname{Courier}r}  Bits korrigieren, so ist die Wortfehlerwahrscheinlichkeit 
%  gegeben durch die Summe der Wahrscheinlichkeiten,  {\fontname{Courier}r+1, r+2, ... n} 
%  Bitfehler unter den emfangenen  {\fontname{Courier}n}  Bits vorzufinden.  Wir berechnen diese 
%  Binomialverteilung direkt durch die Summe der Terme nach der Newton'schen Formel
%        n                                          %<'FontName',MSVFORMFONT>
%  p_w = _{\fontsize{26}\Sigma} (n!/(m!\cdot(n-m)!) p^m (1-p)^{n-m}) %<'FontName',MSVFORMFONT>
%      m=r+1                                          %<'FontName',MSVFORMFONT>
%
%  Hufig dominiert der Term mit  {\fontname{Courier}m = r + 1}  alle anderen.
%  Das folgende Bild zeigt die Binomialverteilung fr  {\fontname{Courier}n = 7} 
%  bei verschiedenen Werten fr die Bitfehlerwahrscheinlichkeit  {\fontname{Courier}p} .
%  Der {\fontname{Courier}(7,4)}-Hammingcode kann maximal eines von  {\fontname{Courier}7} Codewortbits 
%  korrigieren, d.h.  {\fontname{Courier}r = 1} .  Die Wortfehlerwahrscheinlichkeit 
%  ergibt sich also aus den Diagrammen durch Summation aller 
%  Werte fr  {\fontname{Courier}m = 2,...,7} .
%
fehl_vert(7,[0.1,0.01; 0.001,0.0001],1);
%
fehl_vert(23,[0.1,0.01; 0.001,0.0001],1);
%
%  Um die Bitfehlerwahrscheinlichkeiten vergleichen zu knnen, muss diese 
%  Wortfehlerwahrscheinlichkeit in die Bitfehlerwahrscheinlichkeit gewandelt 
%  werden.  Das ist allgemein nur approximativ mglich.  Wir nehmen den 
%  durchaus hufigen schlimmsten Fall an, dass ein falsch decodiertes 
%  Codewort keine hnlichkeit mit dem korrekten aufweist.  Von den 
%  decodierten  {\fontname{Courier}k}  Informationsbits sind daher im Mittel  {\fontname{Courier}k/2} 
%  falsch oder positiv ausgedrckt:  selbst im Fall eines Decodierfehlers 
%  werden noch durchschnittlich  {\fontname{Courier}k/2} Bits zufllig richtig sein. 
%  Deshalb ist die Bitfehlerwahrscheinlichkeit fr decodierte Bits
%
%  Pb = pw/2          %<'FontName',MSVFORMFONT>
%
%  Die Funktion  {\fontname{Courier}plot_code_gain}  zeichnet diese Bitfehlerwahr-
%  scheinlichkeit ber  {\fontname{Courier}E_b/N_0} :
%
help plot_code_gain
%
plot_code_gain
%
%  Aus dem Bild entnimmt man:
%
%  1.  Bei gutem Signal/Rauschverhltnis ist der durch Codierung
%      erzielbare Gewinn hoch.  Die Bitfehlerrate des Golay-Codes 
%      ist bei  {\fontname{Courier}E_b/N_0 = 10 dB}  schon um mehr als  {\fontname{Courier}3}  Dekaden besser 
%      als ohne Benutzung eines Codes.
%
%  2.  Bei geringem Signal/Rauschverhltnis werden die Decodierfehler
%      so hufig, dass die Bitfehlerrate der uncodierten bertragung 
%      besser ist.
%
%  3.  Es gibt Codes, bei denen die Verhltnisse umgekehrt erscheinen:
%      Bei ihnen ist die resultierende Bitfehlerrate bei gutem  {\fontname{Courier}E_b/N_0} 
%      schlechter als bei uncodierter bertragung, jedoch bei sehr 
%      kleinem {\fontname{Courier}E_b/N_0} besser.  Die Verschlechterung liegt an der 
%      individuellen harten Entscheidung der Bits.  Dieser Punkt wird
%      noch im Abschnitt (b) behandelt.
%
%  Begrnder der Informationstheorie ist Shannon.  Unter anderem leitete er 
%  her, dass die bertragungsrate  [in Information/s]  durch das 
%  Signal/Rauschverhltnis prinzipiell begrenzt ist auf die sogenannte 
%  Kanalkapazitt  {\fontname{Courier}C} :
%
%  C = W log_2(1 + S/N_0W),   %<'FontName',MSVFORMFONT>
%
%  wo  {\fontname{Courier}W}  die Bandbreite des Kanals ist, {\fontname{Courier}S} die Leistung des Signals 
%  und  {\fontname{Courier}N_0}  die Rauschleistung pro Bandbreite.
%
%  Aus dieser Beziehung lsst sich herleiten, dass fr jede 
%  Kommunikation gelten muss:
%  E_b/N_0 \geq ln(2) = 0.69315   entsprechend   E_b/N_0 \geq -1.592 dB%<'FontName',MSVFORMFONT>
%
%  Diese Grenze gibt klar an, welche Energie pro zu bertragendem 
%  Informationsbit erforderlich ist bei gegebenem Rauschen  {\fontname{Courier}N_0} , und 
%  zwar unabhngig von allen anderen Grssen wie Bandbreite, Modulation,
%  Filterkombinationen, Bitraten, Codierung etc..  Die Qualitt eines 
%  Informationsbertragungssystems ist daran zu messen, wie nahe es 
%  dieser Grenze kommt.
%
%  Wir tragen diese Grenze noch in das Diagramm der Bitfehlerwahr-
%  scheinlichkeiten ein, indem wir den nicht mglichen Bereich rot
%  einfrben. Ausserdem frben wir alles oberhalb der Grenze  {\fontname{Courier}0.5} 
%  (Zufallsbits) grau:
%
plot_code_gain
ebNoMin = 10*log10(log(2));
patch([-5,ebNoMin,ebNoMin,-5],[1e-12 1e-12 1 1],'r')
xl = get(gca,'XLim');
patch([xl,reverse(xl)],[0.5,0.5,1,1],0.7*[1 1 1])
%
%  Alle hier gezeigten Codes sind ernchternd weit weg vom theoretischen 
%  Optimum, insbesondere bei kleinem  {\fontname{Courier}E_b/N_0} .   Schon bei  {\fontname{Courier}E_b/N_0 = -1 dB} 
%  msste die Bitfehlerrate unter jede Schranke zu bringen sein.
%
%  (b) Es ist noch der Fall zu besprechen, in dem das analog empfangene 
%  Wort als ganzes entschieden wird.  Dieses Wort habe  {\fontname{Courier}n}  Bit.  Das Rauschen 
%  in jedem dieser  {\fontname{Courier}n}  Bits sei normalverteilt mit der Standardabweichung  
%  \sigma = (2rE_b/N_0)^{-1/2}   %<'FontName',MSVFORMFONT>
%
%  Der Rauschanteil des Bits  {\fontname{Courier}i}  sei  {\fontname{Courier}n_i} .  Dann ist der euklidische Abstand 
%  des empfangenen Wortes vom gesendeten
%    n                                    %<'FontName',MSVFORMFONT>
%  (_{\fontsize{26}\Sigma} n_i^2)^{1/2}   %<'FontName',MSVFORMFONT>
%   i=1                                   %<'FontName',MSVFORMFONT>
%
%  Die Frage ist nun, wie wahrscheinlich ist es, dass dieser Abstand vom 
%  gesendeten Wort grsser ist als der Abstand von einem der anderen 
%  gltigen Codewrter. Dann nmlich wird falsch decodiert.
%
%  Zunchst ein realistisches Beispiel fr ein Empfangssignal und dessen 
%  uncodierte Bitentscheidung.
%
b = wcrfir(30,0.0795,0.7); 
[anzahlbits,anzahlbitfehler] = txrxfilter(b,b,4)
%
%  Dieses msste man mehrfach wiederholen, um genauere Aussagen ber die
%  Fehlerrate machen zu knnen.
%
%  Die folgende Funktion ermittelt solche Fehlerraten fr mehrere Flle:
%  ohne Codierung, mit {\fontname{Courier}(7,4)}-Hamming-Codierung und hier fr beide 
%  Methoden der Decodierung.
%  fb  :  Anzahl der Bitfehler des gesamten codierten Datenstroms      %<'FontName',MSVFORMFONT>
%  fh  :  Anzahl der Bitfehler der hart decodierten Information        %<'FontName',MSVFORMFONT>
%  fw  :  Anzahl der Bitfehler der weich decodierten Information       %<'FontName',MSVFORMFONT>
%  fi  :  Anzahl der Bitfehler der Informationsbits in den Codewrtern %<'FontName',MSVFORMFONT>
%  fo  :  Anzahl der Bitfehler ohne Codierung bei demselben E_b/N_0    %<'FontName',MSVFORMFONT>
%
%%  Die Simulation fr  {\fontname{Courier}100000} bertragene Bits dauert ca. {\fontname{Courier}30} Sekunden
%%  Das Resultat erscheint im Kommandofenster:
%
[fb,fh,fw,fi,fo] = simsoftdecode(100000,6)
%
%  Auch die folgende Simulation qult den Prozessor eine Weile. 
%  Es handelt sich um die Codierung mit einem sehr leistungsfhigen 
%  Faltungscode (fr deep space communication).
%  Gezeigt wird das Histogramm des empfangenen Signals nach der 
%  Filterung, welches dem Soft-Decoder angeboten wird. Die Symbole 
%  liegen bei  {\fontname{Courier}\{-1, +1\}} , alles andere ist Rauschen.  Numerisch 
%  ausgegeben wird die Anzahl der Bitfehler nach der Decodierung.
%  
faltcodesim(4,10,16,0)
%
%%  Aufgabe 6.3: Wiederholen Sie die Simulation  faltcodesim(4,10,16,0)
%%  wenigstens zehnmal.
%%
%%  Aufgabe 6.4: Wiederholen Sie die Simulation 
%%  [fb,fh,fw,fi,fo] = simsoftdecode(anzahlbits,sigma)
%%  fr mehrere Werte der Standardabweichung des Rauschens  sigma. 
%%  Dabei ist die Anzahl der Bits anzahlbits jeweils so zu whlen, 
%%  dass einerseits eine statistisch vernnftige Aussage zu machen 
%%  ist und andererseits diese Aussage vor dem Ende der Welt noch 
%%  diskutiert werden kann.
%%  Die Resultate sind mit Fehlerbalken in das Diagramm einzutragen.
%
%
%  c. Codeverzahnung (Interleaving)
%
%  Bei vielen Kanlen treten Fehler zeitlich lokal in sogenannten 
%  Bndeln (engl. burst) auf. Besonders magnetische und optische 
%  Speichermedien und Funkkanle haben diese Eigenschaft.  Auf 
%  solchen Kanlen benutzte Codes mssen Fehlerbndel bis zu 
%  einer vorgegebenen Lnge korrigieren knnen.  Eine verbreitete 
%  Methode hierzu ist das Verzahnen (interleaving) von Codewrtern.
%
%  Beispiel:  Je  {\fontname{Courier}m}  Kodewrter des  {\fontname{Courier}(7,4)}-Hamming-Kodes sollen 
%  die Zeilen einer  {\fontname{Courier}m\times7}-Matrix bilden.  Diese Matrix ist der 
%  eigentliche Block des Kodes.  Die Matrix wird spaltenweise 
%  bertragen und am Empfangsort spaltenweise in die Matrix 
%  eingegeben.  Die Dekodierung erfolgt dann zeilenweise.
%
%%  Das folgende MATLAB-Skript erwartet die Eingabe der Anzahl  m  der 
%%  Hamming-Kodewrter pro Block  (z.B.  8)  sowie die Lnge des 
%%  Fehlerbndels  (z.B. 8)
%
 % Information und ihre Codierung
k = 4; n = 7;  % Parameter des Hamming-Kodes
c = inputdlg('Anzahl der Hamming-Kodewrter pro Block','Tastatureingabe'); 
m = eval(c{1});
c = inputdlg('Lnge des Fehlerbndels','Tastatureingabe'); 
fblaenge = eval(c{1});
infowort = randb(m*k);                   % Information
G = [1 0 0 0 1 0 1; 0 1 0 0 1 1 1; 0 0 1 0 1 1 0; 0 0 0 1 0 1 1];
codematr = mod( reshape(infowort,m,k)*G ,2);   % Kodierung
codewort = reshape(codematr,1,m*n);      % Block-Kodewort

 % Kanalsimulation durch Fehlerbndel der Lnge fblaenge 
fbanfang = ceil((m*k-fblaenge)*rand);    % Anfang des Fehlerbndels
fwort = zeros(1,m*n);
fwort(fbanfang+[0 fblaenge-1])   = 1;    % Fehlerbndel: Anfang und Ende
fwort(fbanfang+(1:(fblaenge-2))) = randb(fblaenge-2); % Fehlerbndel
fcodwort = mod(codewort+fwort,2);        % Anbringen des Fehlers

 % Decodierung und Korrektur
empfmatr = reshape(fcodwort,m,n);        % einlesen in Matrix
H = [G(:,5:7);eye(3)];                   % Prfmatrix
s = mod( empfmatr*H ,2)                  % Syndrome
fbit = [0 7 6 4 5 1 3 2];                % Zuordnung Syndrom => Fehlerstelle
fmat = zeros(m,n);
for k=1:m  fb = fbit(1+binmat2num(s(k,:))); if fb  fmat(k,fb) = 1; end; end
korrmat  = xor(empfmatr,fmat);           % Korrerktur
korrinfo = flach(korrmat(:,1:4)');       % korrigierte Information

 % Ausgabe ins Kommandofenster
infobits = binmatout(infowort)           % zu sendende Informationsbits
codmatrix= binmatout(codematr)           % Codematrix aus 8 (7,4)-Codewrtern
codebits = binmatout(codewort)           % Spalten der Codematrix konkateniert
empfbits = binmatout(fcodwort)           % empfangene Bits
fehlbits = binmatout(codewort~=fcodwort) % fehlerhafte Bitpositionen 
korrbits = binmatout(korrinfo)           % korrigierte Information
infofehl = binmatout(korrinfo~=infowort) % fehlerhafte Bitpositionen der Information
Anzahlfehler = sum(korrinfo~=infowort)   % Anzahl der Bitfehler nach der Korrektur
%
%%  Aufgabe 6.5:  Ermitteln Sie die Antworten zu folgenden Fragen:
%%
%%  (a) Wie viele Bitfehler kann dieser Code maximal korrigieren?
%%
%%  (b) Wie viele Bitfehler kann dieser Code minimal korrigieren?
%%
%%  (c) Welche Fehlerbndellnge kann dieser Code korrigieren?
%
%  Hinweis:  Die Audio-CD erreicht mit mehrfach verschachteltem Code plus
%  Verzahnung, dass Fehlerbndel in den gelesenen Bits bis zu  {\fontname{Courier}9408} Bits 
%  lang sein drfen ohne dass die Ausgabe sich verndert.  Bei Fehlerbndeln 
%  bis zur Lnge  {\fontname{Courier}30576}  kann zeitlich punktuell interpoliert werden, 
%  was vllig unhrbar ist ({\fontname{Courier}7 mm}  breiter Kratzstreifen auf der CD).  
%  Ist die CD jedoch groflchig beschdigt, hilft die Verzahnung nicht. 
%
%%  Aufgabe 6.6:  Berechnung der Bitfehlerwahrscheinlichkeit
%%  Wir nehmen jetzt an , es gbe keinerlei Korrelation zwischen den 
%%  Fehlern, also keine Fehlerbndel.  Die Bits werden vor der Decodierung 
%%  hart entschieden.  Die Wahrscheinlichkeit, ein bestimmtes Bit fehlerhaft 
%%  vorzufinden, sei p.  Wie gross ist die Bitfehlerrate bei den decodierten
%%  Informationsbits?  Betrachten Sie bei der Berechnung nur r-Bitfehler 
%%  in den Hammingcodewrtern mit  r = 1, 2, 3   und beachten Sie, dass 
%%  Zweibitfehler bei der Decodierung des Hammingcodes zu Dreibitfehlern 
%%  werden. 
%%
%%  Stellen Sie zunchst die Formel auf.  Anschliessend ist mit MATLAB
%%  das Diagramm zu plotten:  Informationsbitfehlerrate ber Bitfehlerrate.
%%
%%  Die Wahrscheinlichkeit, unter  m  Ereignissen  n bestimmte vorzufinden,
%%  deren Wahrscheinlichkeit  p  ist, ist nach Newton in MATLAB-Syntax:
%  binko(m,n)*p^n*(1-p)^(m-n)  %<'FontName',MSVFORMFONT,'interpreter','none'>
%
%%  Das Plotkommando kann hier in seiner einfachsten Form
%  plot(Vektor)                %<'FontName',MSVFORMFONT>
%
%%  Benutzt werden.
%
%
%%  Aufgabe 6.7:  Bitfehlerrate bei Automatic Repeat Request (ARQ)
%%  Beim oben behandelten Blockcode wird die Redundanz vollstndig 
%%  zur Vorwrts-Fehlerkorrektur verwendet.  Im Fall von ARQ ist 
%%  dagegen eine Fehlererkennung ntig. 
%%
%%  Betrachten Sie zwei Flle:
%%
%%  a. Die gesamte Redundanz wird zur Fehlererkennung bentzt.
%%
%%  b. Es enthlt 32 Informationsbits und 24 Parittsbits.
%
