function  b = wcrfir(g,fo,r)
% b = wcrfir(g,fo,r)
% Berechnung von FIR-Filtern mit Wurzelkosinusrolloffflanke.
% g  = Filtergrad (muss gerade und grsser als 1 sein)
% fo = Lage der Flanke relativ zur Nyquistfrequenz
% r  = Rollofffaktor
% Beispiel:  b = wcrfir(14,0.2,0.5);

% Autor: Klaus von der Heide, e-mail:  v.d.heide@on-line.de

if g<2 error('g > 1  nicht erfllt.'); end;
n = g + 2;
if rem(n,2)~=0 error('g muss gerade sein.'); end;
ff = (0:n-1)/n;                 % Frequenzbereich 0 bis Abtastfrequenz
f  = ff(1:n/2);                 % Frequenzbereich 0 bis Nyquistfrequenz
for k = 1:n/2                   % Frequenzgang 0 bis Nyquistfrequenz
   w(k) = sqrt(cosrolloff(2*f(k)/fo,r));
end
wf = [w,w(n/2:-1:1)];           % Frequenzgang 0 bis Abtastfrequenz
iw = ifft(wf);                  % IDFT davon
b  = real([iw(n/2:-1:1),iw(2:n/2)]);  % Impulsantwort
